#include "mpi.h"
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[])
{
    int my_rank, numprocs;
    char text[100], message[100];
    int p, dest, tag, source;
    MPI_Status status;

    MPI_Init(&argc,&argv);
    MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);

    tag = 0;
    source = my_rank - 1; if ( source < 0 ) source = numprocs-1;
    dest = my_rank + 1; if ( dest >= numprocs ) dest = 0;
    if (my_rank == 0) {
         sprintf(text,"Hello world from process \0");
         MPI_Send(text, sizeof(text),
                MPI_CHAR, dest, tag, MPI_COMM_WORLD);
    }
    MPI_Recv(message, sizeof(message), MPI_CHAR,
                    source, tag, MPI_COMM_WORLD, &status);
    if (my_rank != 0) {
          MPI_Send(message, sizeof(message),
                MPI_CHAR, dest, tag, MPI_COMM_WORLD);
    }
    printf("%s %d\n",message,my_rank);

    MPI_Finalize();

    return 0;
}